<?php
/*
  Plugin Name: WordPress Toolbar
  Version: 1.1
  Plugin URI: http://abhinavsingh.com/blog/2009/02/wordpress-toolbar-plugin
  Description: This plugin provides an interactive toolbar for all outgoing links from your blogpost. Toolbar shows a comment back button as well as several famous bookmarking buttons.
  Author: Abhinav Singh
  Author URI: http://abhinavsingh.com/blog
*/
  
function relative2absolute($absolute, $relative) {
  $p = @parse_url($relative);
  if(!$p) {
    //$relative is a seriously malformed URL
    return false;
  }
  if(isset($p["scheme"])) return $relative;
  $parts=(parse_url($absolute));
  
  if(substr($relative,0,1)=='/') {
    $cparts = (explode("/", $relative));
    array_shift($cparts);
  } 
  else {
    if(isset($parts['path'])) {
      $aparts=explode('/',$parts['path']);
      array_pop($aparts);
      $aparts=array_filter($aparts);
    } 
    else {
      $aparts=array();
    }
    $rparts = (explode("/", $relative));
    $cparts = array_merge($aparts, $rparts);
    foreach($cparts as $i => $part) {
      if($part == '.') {
      unset($cparts[$i]);
      } 
      else if($part == '..') {
        unset($cparts[$i]);
        unset($cparts[$i-1]);
      }
    }
  }
  $path = implode("/", $cparts);
  $url = '';
  if($parts['scheme']) {
    $url = "$parts[scheme]://";
  }
  if(isset($parts['user'])) {
    $url .= $parts['user'];
    if(isset($parts['pass'])) {
      $url .= ":".$parts['pass'];
    }
    $url .= "@";
  }
  if(isset($parts['host'])) {
    $url .= $parts['host']."/";
  }
  $url .= $path;
  
  return $url;
}
  
function my_blog_toolbar($html) {
  /* Get blog url */
  $domain = get_bloginfo('url');
  
  /* Get post url */
  $page_url = get_permalink();
  
  /* Get blog title */
  $blogtitle = get_bloginfo('name');
  
  /* Get post title */
  $posttitle = the_title('','',FALSE);
  
  /* Initialize a link array */
  $links=array();
  
  /* Get all the links */
  preg_match_all('/<a[\s]+[^>]*href\s*=\s*[\"\']?([^\'\" >]+)[\'\" >]/i', $html, $m);
  
  /* Turn relative to absolute url */
  foreach($m[1] as $url) {
    /* trim url */
    $url = trim($url);
    
    /* Turn relative URLs into absolute URLs */
    $url = relative2absolute($page_url, $url);
    
    $links[] = $url;
  }
  
  /* Apply toolbar to external url's */
  $links = array_unique($links);
  $param = "&wp-toolbar-from=".$page_url."&wp-toolbar-home=".$domain."&wp-toolbar-hometitle=".$blogtitle."&wp-toolbar-fromtitle=".$posttitle;
  foreach($links as $link) {
    if(!strstr($link,$domain)) {
      $html = str_replace("'".$link."'", "'".$domain."/toolbar.php?wp-toolbar-url=".$link.$param."'", $html);
      $html = str_replace('"'.$link.'"', '"'.$domain."/toolbar.php?wp-toolbar-url=".$link.$param.'"', $html);
    }
  }
  
  /* Return modified post content */
  return $html;
}

add_filter('the_content','my_blog_toolbar');
  
?>
